<template>
  <div class="app-container">

    <!-- 搜索工作栏 -->
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="90px">
      
      <el-form-item label="提货点名称" prop="titleZh">
        <el-input v-model="queryParams.titleZh" placeholder="请输入名称" clearable @keyup.enter.native="handleQuery"/>
      </el-form-item>

      <!-- <el-form-item label="地区" prop="countryId">
        <el-input v-model="queryParams.countryId" placeholder="请输入国家" clearable @keyup.enter.native="handleQuery"/>
      </el-form-item> -->
      
      <el-form-item label="状态" prop="status">
        <el-select v-model="queryParams.status" placeholder="请选择状态" clearable>
          <el-option v-for="dict in statusDictDatas" :key="parseInt(dict.value)" :label="dict.label" :value="parseInt(dict.value)"/>
        </el-select>
      </el-form-item>

      <el-form-item>
        <el-button type="primary" icon="el-icon-search" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <!-- 操作工具栏 -->
    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="el-icon-plus" size="mini" @click="handleAdd"
                   v-hasPermi="['ecw:pickup-loc:create']">新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="warning" plain icon="el-icon-download" size="mini" @click="handleExport" :loading="exportLoading"
                   v-hasPermi="['ecw:pickup-loc:export']">导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <!-- 列表 -->
    <el-table v-loading="loading" :data="list" @sort-change="sortChange">
      <el-table-column label="序号" type="index" width="50" />
   
      <el-table-column label="提货点名称" align="center" prop="titleZh" />
      <el-table-column label="排序" sortable="custom" align="center" prop="sort" />

      <el-table-column label="地区" align="center" prop="countryId">
          <template slot-scope="scope">
              <span>{{ getCountryName(scope.row.countryId) }}</span>
          </template>
      </el-table-column>
     
      <el-table-column prop="status" label="状态" width="100">
        <template slot-scope="scope">
          <el-switch v-model="scope.row.status" :active-value="CommonStatusEnum.ENABLE" :inactive-value="CommonStatusEnum.DISABLE" @change="handleStatusChange(scope.row)" />
        </template>
      </el-table-column>
      
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button size="mini" type="text" icon="el-icon-edit" @click="handleUpdate(scope.row)"
                     v-hasPermi="['ecw:pickup-loc:update']">修改</el-button>
          <el-button size="mini" type="text" icon="el-icon-delete" @click="handleDelete(scope.row)"
                     v-hasPermi="['ecw:pickup-loc:delete']">删除</el-button>
        </template>
      </el-table-column>

    </el-table>
    <!-- 分页组件 -->
    <pagination v-show="total > 0" :total="total" :page.sync="queryParams.pageNo" :limit.sync="queryParams.pageSize"
                @pagination="getList"/>

    <!-- 对话框(添加 / 修改) -->
    <el-dialog :title="title" :visible.sync="open" width="700px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="110px">

        <el-form-item label="地区" prop="countryId">
            <el-radio-group v-model="form.countryId">
              <el-radio v-for="item in countryList" :key="item.id" :label="item.id">{{ item.titleZh }}</el-radio>
            </el-radio-group>
        </el-form-item>
        

        <el-form-item label="名称" prop="titleZh">
          <el-input v-model="form.titleZh" placeholder="请输入名称" />
        </el-form-item>
        <el-form-item label="英文名称" prop="titleEn">
          <el-input v-model="form.titleEn" placeholder="请输入英文名称" />
        </el-form-item>
        <el-form-item label="工作时间" prop="workTime">
          <el-input v-model="form.workTime" placeholder="请输入工作时间" />
        </el-form-item>
        <el-form-item label="联系方式" prop="contact">
          <el-input v-model="form.contact" placeholder="请输入联系方式" />
        </el-form-item>
        <el-form-item label="提货点地址" prop="address">
          <el-input v-model="form.address" placeholder="请输入提货点地址" />
        </el-form-item>
        <el-form-item label="提货点信息" prop="detailZh">
          <el-input v-model="form.detailZh" placeholder="请输入提货点信息" />
        </el-form-item>
        <el-form-item label="英文提货点信息" prop="detailEn">
          <el-input v-model="form.detailEn" placeholder="请输入提货点英文信息" />
        </el-form-item>
        <el-form-item label="排序" prop="sort">
          <el-input v-model="form.sort" placeholder="请输入排序" type="number" />
        </el-form-item>

        <el-form-item label="状态" prop="status">
          <el-select v-model="form.status" placeholder="请选择状态">
            <el-option v-for="dict in statusDictDatas" :key="parseInt(dict.value)" :label="dict.label" :value="parseInt(dict.value)"/>
          </el-select>
        </el-form-item>

      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { createPickupLoc, updatePickupLoc, deletePickupLoc, getPickupLoc, getPickupLocPage, exportPickupLocExcel } from "@/api/ecw/pickupLoc";
import {CommonStatusEnum} from '@/utils/constants'
import { getDictDatas, DICT_TYPE } from '@/utils/dict'
import { getListTree } from "@/api/ecw/region";

export default {
  name: "PickupLoc",
  components: {
  },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,

      //国家信息列表
      countryList: [],  

      // 自提点列表
      list: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      dateRangeWorkTime: [],
      dateRangeCreateTime: [],
      // 查询参数
      queryParams: {
        pageNo: 1,
        pageSize: 10,
        countryId: null,
        titleZh: null,
        titleEn: null,
        contact: null,
        address: null,
        detailZh: null,
        detailEn: null,
        sort: null,
        status: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        countryId: [{ required: true, message: "地区不能为空", trigger: "blur" }],
        titleZh: [{ required: true, message: "名称不能为空", trigger: "blur" }],
        sort: [{ required: true, message: "排序不能为空", trigger: "blur" }],
      },
       // 枚举
      CommonStatusEnum: CommonStatusEnum,
      // 数据字典
      statusDictDatas: getDictDatas(DICT_TYPE.COMMON_STATUS),

      sortProp: null,
      sortType: null,
    };
  },
  created() {
    this.getList();
    this.getCountryList();
  },
  methods: {
    /** 查询列表 */
    getList() {
      this.loading = true;
      // 处理查询参数
      let params = {...this.queryParams};
      params.sortProp = this.sortProp;
      params.sortType = this.sortType;
      this.addBeginAndEndTime(params, this.dateRangeWorkTime, 'workTime');
      this.addBeginAndEndTime(params, this.dateRangeCreateTime, 'createTime');
      // 执行查询
      getPickupLocPage(params).then(response => {
        this.list = response.data.list;
        this.total = response.data.total;
        this.loading = false;
      });
    },

    sortChange(obj) {
      this.sortProp = obj.prop;   //排序字段名称
      this.sortType = obj.order;   //排序方式
      this.queryParams.pageNo = 1;
      this.getList();
    },

    getCountryList() {
        this.queryParams.treeType = 1;
        getListTree(this.queryParams).then(response => {
          this.countryList = response.data;
      });
    },

    getCountryName(countryId) {
      for(let index in this.countryList) {
        let country = this.countryList[index];
        if(country.id == countryId) return country.titleZh;
      }
    },

    /** 取消按钮 */
    cancel() {
      this.open = false;
      this.reset();
    },
    /** 表单重置 */
    reset() {
      this.form = {
        id: undefined,
        countryId: undefined,
        titleZh: undefined,
        titleEn: undefined,
        workTime: undefined,
        contact: undefined,
        address: undefined,
        detailZh: undefined,
        detailEn: undefined,
        sort: undefined,
        status: undefined,
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNo = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.dateRangeWorkTime = [];
      this.dateRangeCreateTime = [];
      this.resetForm("queryForm");
      this.handleQuery();
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加自提点";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id;
      getPickupLoc(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改自提点";
      });
    },

     handleStatusChange(row) {
      let text = row.status === CommonStatusEnum.ENABLE ? "启用" : "停用";
      this.$modal.confirm('确认要' + text + '编号为' + row.id + '的数据吗?').then(function() {
        return updatePickupLoc(row);

      }).then(() => {
        this.$modal.msgSuccess(text + "成功");
      }).catch(function() {
        row.status = row.status === CommonStatusEnum.ENABLE ? CommonStatusEnum.DISABLE
          : CommonStatusEnum.ENABLE;
      });
    },

    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (!valid) {
          return;
        }
        // 修改的提交
        if (this.form.id != null) {
          updatePickupLoc(this.form).then(response => {
            this.$modal.msgSuccess("修改成功");
            this.open = false;
            this.getList();
          });
          return;
        }
        // 添加的提交
        createPickupLoc(this.form).then(response => {
          this.$modal.msgSuccess("新增成功");
          this.open = false;
          this.getList();
        });
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const id = row.id;
      this.$modal.confirm('是否确认删除自提点编号为"' + id + '"的数据项?').then(function() {
          return deletePickupLoc(id);
        }).then(() => {
          this.getList();
          this.$modal.msgSuccess("删除成功");
        }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      // 处理查询参数
      let params = {...this.queryParams};
      params.pageNo = undefined;
      params.pageSize = undefined;
      this.addBeginAndEndTime(params, this.dateRangeWorkTime, 'workTime');
      this.addBeginAndEndTime(params, this.dateRangeCreateTime, 'createTime');
      // 执行导出
      this.$modal.confirm('是否确认导出所有自提点数据项?').then(() => {
          this.exportLoading = true;
          return exportPickupLocExcel(params);
        }).then(response => {
          this.$download.excel(response, '${table.classComment}.xls');
          this.exportLoading = false;
        }).catch(() => {});
    }
  }
};
</script>
